(*
 * The contents of this file are subject to the ICS(TM) Community Research
 * License Version 2.0 (the ``License''); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.icansolve.com/license.html.  Software distributed under the
 * License is distributed on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing rights and limitations under the License.  The Licensed Software
 * is Copyright (c) SRI International 2003, 2004.  All rights reserved.
 * ``ICS'' is a trademark of SRI International, a California nonprofit public
 * benefit corporation.
 *)

(** Operations on uninterpreted terms

  @author Harald Ruess

  Currently not used. But here goes the forward chaining rules.
*)

val sigma : Sym.t -> Term.t list -> Term.t

val lazy_sigma : Term.t -> Sym.t -> Term.t list -> Term.t


val is_uninterp : Term.t -> bool
  (** [is_uninterp a] holds iff the function symbol of [a] is
    uninterpreted (see module [Sym]). *)


val d_uninterp : Term.t -> Sym.t * Term.t list
  (** For a term [a] such that [is_uninterp a] holds, [d_uninterp a]
    returns the uninterpreted function symbol and the argument list of [a]. *)

val map : (Term.t -> Term.t) -> Term.t -> Term.t
